@ECHO off


SET OWNER=
SET OWNERPASS=
SET DIR=logs
SET RESPONSE=
SET LOC=
SET CON=
SET FILENAME=RPMVERSION.bat
SET VALID_COUNT=
SET ORIGINAL_PATH=%PATH%

echo.
echo ******************************************************************
echo *              RPM Testfix 7111_TESTFIX00259258                  *
echo *                                                                *
echo * This testfix runs on RPM version 7.1.1.1.                      *
echo * Please make sure that you have a backup of your database       *
echo * before running the testfix.                                    *
echo *                                                                *
echo ******************************************************************
echo.



REM echo Please make sure that you have a backup of your database.


SET RESPONSE=

:ask_pre_mig

SET /p RESPONSE=Do you have a backup of your database?(y/n)

IF "%RESPONSE%" EQU "Y" GOTO after_pre_mig
IF "%RESPONSE%" EQU "y" GOTO after_pre_mig

IF "%RESPONSE%" EQU "n" GOTO err_nobk
IF "%RESPONSE%" EQU "N" GOTO err_nobk

echo Invalid entry!
goto ask_pre_mig

:after_pre_mig





REM asking ORACLE_HOME





if "%ORACLE_HOME%" EQU "" goto ask_ORACLE_HOME_2
echo **********************************************************************
echo  The script has verified that ORACLE_HOME is set to %ORACLE_HOME%
echo **********************************************************************




:ask_ORACLE_HOME

SET RESPONSE=
SET /p RESPONSE=Is this the right value?(y/n)

IF "%RESPONSE%" EQU "Y" GOTO after_ORACLE_HOME
IF "%RESPONSE%" EQU "y" GOTO after_ORACLE_HOME

IF "%RESPONSE%" EQU "n" GOTO ask_ORACLE_HOME_2
IF "%RESPONSE%" EQU "N" GOTO ask_ORACLE_HOME_2

echo Invalid entry!
goto ask_ORACLE_HOME




:ask_ORACLE_HOME_2

SET ORACLE_HOME=
SET /p ORACLE_HOME=Please enter ORACLE_HOME:
IF "%ORACLE_HOME%" NEQ "" GOTO after_ORACLE_HOME
echo Invalid entry!
goto ask_ORACLE_HOME_2

:after_ORACLE_HOME

REM check if sqlplus exists

if not exist %ORACLE_HOME%\bin\sqlplus.exe goto no_sqlplus

REM add oracle_home\bin to path
IF EXIST %FILENAME% DEL %FILENAME%

SET PATH=%PATH%;%ORACLE_HOME%\bin



:ask_loc

SET LOC=
SET /p LOC=Is your RPM database installed on this machine?(y/n)
IF "%LOC%" EQU "Y" SET LOC="y"
IF "%LOC%" EQU "N" SET LOC="n"

IF "%LOC%" EQU "y" GOTO after_loc
IF "%LOC%" EQU "n" GOTO ask_ORACLE_SID_2
echo Invalid entry!
goto ask_loc


:after_loc


REM checking ORACLE_SID

if "%ORACLE_SID%" EQU "" goto ask_ORACLE_SID_2
echo **********************************************************************
echo  The script has verified that ORACLE_SID is set to %ORACLE_SID%
echo **********************************************************************




:ask_ORACLE_SID

SET RESPONSE=
SET /p RESPONSE=Is this the right value?(y/n)

IF "%RESPONSE%" EQU "Y" GOTO after_ORACLE_SID
IF "%RESPONSE%" EQU "y" GOTO after_ORACLE_SID

IF "%RESPONSE%" EQU "n" GOTO ask_ORACLE_SID_2
IF "%RESPONSE%" EQU "N" GOTO ask_ORACLE_SID_2

echo Invalid entry!
goto ask_ORACLE_SID




:ask_ORACLE_SID_2

SET ORACLE_SID=
IF "%LOC%" EQU "n" SET /p ORACLE_SID=Please enter TNS string:
IF "%LOC%" EQU "y" SET /p ORACLE_SID=Please enter ORACLE_SID:
IF "%ORACLE_SID%" NEQ "" GOTO after_ORACLE_SID
echo Invalid entry!
goto ask_ORACLE_SID_2

:after_ORACLE_SID


REM Checking OWNER

:ask_owner

SET OWNER=
SET /p OWNER=Please enter IBMRPM schema owner:
IF "%OWNER%" NEQ "" GOTO after_owner
echo Invalid entry!
goto ask_owner

:after_owner


REM Checking OWNERPASS

:ask_owner_pass

SET OWNERPASS=
SET /p OWNERPASS=Please enter IBMRPM schema owner password:
IF "%OWNERPASS%" NEQ "" GOTO after_owner_pass
echo Invalid entry!
goto ask_owner_pass

:after_owner_pass

REM Checking Loc



SET CON=
if "%LOC%" EQU "y"  SET CON=%OWNER%/%OWNERPASS%
if "%LOC%" EQU "Y"  SET CON=%OWNER%/%OWNERPASS%
if "%LOC%" EQU "n"  SET CON=%OWNER%/%OWNERPASS%@%ORACLE_SID%
if "%LOC%" EQU "N"  SET CON=%OWNER%/%OWNERPASS%@%ORACLE_SID%

sqlplus -S /nolog @scripts\check\check_con.sql %CON%
IF "%ERRORLEVEL%" NEQ "0" goto err_no_con


IF NOT EXIST logs mkdir logs

IF EXIST %FILENAME% DEL %FILENAME%


echo.
echo ***********************************************************
echo * Testfix script has gathered all the necessary information 
echo * to apply the testfix on your database. After applying the 
echo * testfix, you cannot go back to the old version unless you
echo * use your database backup.
echo ***********************************************************
echo.
:ask_sure

SET RESPONSE=
SET /p RESPONSE=Are you sure you want to apply the testfix to your database now?(y/n)
IF "%RESPONSE%" EQU "Y" GOTO after_sure
IF "%RESPONSE%" EQU "y" GOTO after_sure
IF "%RESPONSE%" EQU "n" GOTO cancel_mig
IF "%RESPONSE%" EQU "N" GOTO cancel_mig
echo Invalid entry!
goto ask_sure

:after_sure



sqlplus -S %CON% @scripts\check\recycle.sql >> %FILENAME%
IF EXIST %FILENAME% DEL %FILENAME%



sqlplus -S %CON% @scripts/step1.sql
REM sqlplus -S %CON% @scripts/step2.sql

REM check number of valid objects

sqlplus -S %CON% @scripts\check\check_valid.sql >>%FILENAME%

SET VALID_COUNT=
CALL %FILENAME%

IF EXIST %FILENAME% DEL %FILENAME%

echo.
echo **********************
echo * RPM Testfix Report
echo **********************
echo. 
echo  There are %VALID_COUNT% invalid objects in RPM after applying the testfix.
echo. 
echo ************************************************
echo * Testfix logs are created in the logs folder.   
echo * End of testfix 7111_TESTFIX00259258.       
echo * Exiting RPM Testfix 7111_TESTFIX00259258.  
echo ************************************************
echo.
IF EXIST %FILENAME% DEL %FILENAME%

goto EXT

:err_nobk
	echo.
	echo ************************************************************************
	echo * Testfix was not applied.                                             *
	echo * Reason: no backup.                                                   *
	echo * Please try the testfix after getting a backup of your database.      *
	echo * Exiting RPM Testfix 7111_TESTFIX00259258.                            *
	echo ************************************************************************
	echo.
GOTO EXT

:err_no_con
	echo.
	echo ***********************************************************************
	echo * Testfix was not applied.                                            *
	echo * Reason: Unable to connect to RPM database.                          *
	echo * Exiting RPM Testfix 7111_TESTFIX00259258.                           *
	echo ***********************************************************************
	echo.
	goto EXT

:cancel_mig
	echo.
	echo **********************************************************************
	echo * Testfix was not applied.                                           *
	echo * Reason: Migration was cancelled by the user.                       *
	echo * Exiting RPM Testfix 7111_TESTFIX00259258.                          *
	echo **********************************************************************
	echo.
	goto EXT



:no_sqlplus
	echo.
	echo *********************************************************************
	echo * Testfix was not applied.                                         
	echo * Reason: sqlplus not found in %ORACLE_HOME%\bin directory.               
	echo * Exiting RPM Testfix 7111_TESTFIX00259258.                                   
	echo *********************************************************************
	echo.
	goto EXT




:EXT
SET PATH=%ORIGINAL_PATH%
IF EXIST %FILENAME% DEL %FILENAME%
SET REPLY=
SET DB=
SET USER=
SET PASS=
SET LOC=


